package b4a.serviceexample;

import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.objects.ServiceHelper;
import anywheresoftware.b4a.debug.*;

public class testservice extends android.app.Service {
	public static class testservice_BR extends android.content.BroadcastReceiver {

		@Override
		public void onReceive(android.content.Context context, android.content.Intent intent) {
			android.content.Intent in = new android.content.Intent(context, testservice.class);
			if (intent != null)
				in.putExtra("b4a_internal_intent", intent);
			context.startService(in);
		}

	}
    static testservice mostCurrent;
	public static BA processBA;
    private ServiceHelper _service;
    public static Class<?> getObject() {
		return testservice.class;
	}
	@Override
	public void onCreate() {
        mostCurrent = this;
        if (processBA == null) {
		    processBA = new BA(this, null, null, "b4a.serviceexample", "b4a.serviceexample.testservice");
            try {
                Class.forName(BA.applicationContext.getPackageName() + ".main").getMethod("initializeProcessGlobals").invoke(null, null);
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
            processBA.loadHtSubs(this.getClass());
            ServiceHelper.init();
        }
        _service = new ServiceHelper(this);
        processBA.service = this;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Service (testservice) Create **");
        processBA.raiseEvent(null, "service_create");
    }
		@Override
	public void onStart(android.content.Intent intent, int startId) {
		handleStart(intent);
    }
    @Override
    public int onStartCommand(android.content.Intent intent, int flags, int startId) {
    	handleStart(intent);
		return android.app.Service.START_STICKY;
    }
    private void handleStart(android.content.Intent intent) {
    	BA.LogInfo("** Service (testservice) Start **");
    	java.lang.reflect.Method startEvent = processBA.htSubs.get("service_start");
    	if (startEvent != null) {
    		if (startEvent.getParameterTypes().length > 0) {
    			anywheresoftware.b4a.objects.IntentWrapper iw = new anywheresoftware.b4a.objects.IntentWrapper();
    			if (intent != null) {
    				if (intent.hasExtra("b4a_internal_intent"))
    					iw.setObject((android.content.Intent) intent.getParcelableExtra("b4a_internal_intent"));
    				else
    					iw.setObject(intent);
    			}
    			processBA.raiseEvent(null, "service_start", iw);
    		}
    		else {
    			processBA.raiseEvent(null, "service_start");
    		}
    	}
    }
	@Override
	public android.os.IBinder onBind(android.content.Intent intent) {
		return null;
	}
	@Override
	public void onDestroy() {
        BA.LogInfo("** Service (testservice) Destroy **");
		processBA.raiseEvent(null, "service_destroy");
        processBA.service = null;
		mostCurrent = null;
		processBA.setActivityPaused(true);
	}
public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Timer _timerservice = null;
public static int _counter = 0;
public static anywheresoftware.b4a.objects.NotificationWrapper _noti1 = null;
public b4a.serviceexample.main _main = null;
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 6;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 10;BA.debugLine="Dim TimerService As Timer";
_timerservice = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 11;BA.debugLine="Dim Counter As Int";
_counter = 0;
 //BA.debugLineNum = 13;BA.debugLine="Dim Noti1 As Notification";
_noti1 = new anywheresoftware.b4a.objects.NotificationWrapper();
 //BA.debugLineNum = 15;BA.debugLine="End Sub";
return "";
}
public static String  _service_create() throws Exception{
 //BA.debugLineNum = 16;BA.debugLine="Sub Service_Create";
 //BA.debugLineNum = 18;BA.debugLine="TimerService.Initialize(\"TimerService\",1000)";
_timerservice.Initialize(processBA,"TimerService",(long)(1000));
 //BA.debugLineNum = 19;BA.debugLine="TimerService.Enabled=True";
_timerservice.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 21;BA.debugLine="Noti1.Initialize";
_noti1.Initialize();
 //BA.debugLineNum = 22;BA.debugLine="Noti1.Icon = \"icon\" 'use the application icon file for the notification";
_noti1.setIcon("icon");
 //BA.debugLineNum = 23;BA.debugLine="Noti1.Vibrate = False";
_noti1.setVibrate(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 24;BA.debugLine="Noti1.Sound = False";
_noti1.setSound(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 25;BA.debugLine="Noti1.Light=False";
_noti1.setLight(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 26;BA.debugLine="Noti1.SetInfo(\"Service Example\", \"Counter\", Main)";
_noti1.SetInfo(processBA,"Service Example","Counter",(Object)(mostCurrent._main.getObject()));
 //BA.debugLineNum = 28;BA.debugLine="Service.StartForeground(1, Noti1)";
mostCurrent._service.StartForeground((int)(1),(android.app.Notification)(_noti1.getObject()));
 //BA.debugLineNum = 30;BA.debugLine="End Sub";
return "";
}
public static String  _service_destroy() throws Exception{
 //BA.debugLineNum = 38;BA.debugLine="Sub Service_Destroy";
 //BA.debugLineNum = 40;BA.debugLine="Service.StopForeground(1)";
mostCurrent._service.StopForeground((int)(1));
 //BA.debugLineNum = 41;BA.debugLine="ToastMessageShow(\"Service Stopped!\", False)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Service Stopped!",anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 42;BA.debugLine="Counter = 0";
_counter = (int)(0);
 //BA.debugLineNum = 44;BA.debugLine="End Sub";
return "";
}
public static String  _service_start(anywheresoftware.b4a.objects.IntentWrapper _startingintent) throws Exception{
 //BA.debugLineNum = 32;BA.debugLine="Sub Service_Start (StartingIntent As Intent)";
 //BA.debugLineNum = 34;BA.debugLine="Counter=Counter+1";
_counter = (int)(_counter+1);
 //BA.debugLineNum = 36;BA.debugLine="End Sub";
return "";
}
public static String  _timerservice_tick() throws Exception{
 //BA.debugLineNum = 46;BA.debugLine="Sub TimerService_Tick";
 //BA.debugLineNum = 48;BA.debugLine="StartServiceAt(\"\", DateTime.Now, True)";
anywheresoftware.b4a.keywords.Common.StartServiceAt(processBA,(Object)(""),anywheresoftware.b4a.keywords.Common.DateTime.getNow(),anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 50;BA.debugLine="End Sub";
return "";
}
}
