﻿Type=Service
Version=2.71
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#StartCommandReturnValue: android.app.Service.START_STICKY
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim TimerService As Timer
  	Dim Counter As Int 
	
	Dim Noti1 As Notification

End Sub
Sub Service_Create

	TimerService.Initialize("TimerService",1000)
  	TimerService.Enabled=True
	
	Noti1.Initialize
    Noti1.Icon = "icon" 'use the application icon file for the notification
    Noti1.Vibrate = False
    Noti1.Sound = False	
	Noti1.Light=False
	Noti1.SetInfo("Service Example", "Counter", Main)

    Service.StartForeground(1, Noti1)

End Sub

Sub Service_Start (StartingIntent As Intent)
	
	Counter=Counter+1

End Sub

Sub Service_Destroy

	Service.StopForeground(1)
	ToastMessageShow("Service Stopped!", False)
	Counter = 0

End Sub

Sub TimerService_Tick

  StartServiceAt("", DateTime.Now, True)
  
End Sub
